package ac.essex.ooechs.fractals.colouring;

import java.awt.*;

/**
 * <p/>
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version,
 * provided that any use properly credits the author.
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details at http://www.gnu.org
 * </p>
 *
 * @author Olly Oechsle, University of Essex, Date: 22-Nov-2007
 * @version 1.0
 */
public class FlameColourer implements Colourer {

    public Color getColor(double iterations, int max_iterations)  {
        if (iterations == max_iterations) {
            return black;
        } else {
            double percent = (iterations / max_iterations);

            double red = Math.exp(percent * 2) * 255;
            double green = (percent + 0.5) * 255;
            double blue = (percent - 0.3) * 255;

            red *= percent * 2;
            green *= percent;
            blue *= percent;

            red = Math.max(Math.min(red, 255), 0);
            green = Math.max(Math.min(green, 255), 0);
            blue = Math.max(Math.min(blue, 255), 0);

            return new Color((int) red, (int) green, (int) blue);
        }
    }

}
